#include "Config.oh"

void GrTiles_DrawTile_fastcall (/*unsigned char x, unsigned char y,*/ unsigned char *tile) __z88dk_fastcall;

/*================================== Header ==================================*/

void GrTiles_DrawTile_fastcall (/*unsigned char x, unsigned char y,*/ unsigned char *tile) __naked __z88dk_fastcall {
#asm
        XCHG        ; DE = tile address
PUBLIC  _GrTiles_x  ; x (in tiles, not in pixels)
PUBLIC  _GrTiles_y  ; y (in tiles, not in pixels)
        DB   0x01   ; LXI BC, yx
_GrTiles_x:
        DB   0      ; C = x
_GrTiles_y:
        DB   0      ; B = y
        MOV  A, B   ; y
        ADD  A
        ADD  B      ; * 6
        ADD  A
        MOV  L, A   ; HL = #TAB[y * 6]
        MVI  H, Config_ScreenTable
        MOV  A, M
        ADD  C      ; + x
        INR  H
        MOV  H, M   ; high screen addr byte
        MOV  L, A   ; low screen addr byte
        MVI  B, 12
        XRA  A
        OUT  0xC2   ; Включить видео ОЗУ
DRAWLOOP:
        LDAX D
        MOV  M, A
        INX  H
        INX  D
        LDAX D
        MOV  M, A
        INX  H
        INX  D
        LDAX D
        MOV  M, A
        INX  D
        MOV  A, L
        ADI  0x40-2
        MOV  L, A
        MOV  A, H
        ACI  0
        MOV  H, A
        DCR  B
        JNZ  DRAWLOOP
        MVI  A, 2
        OUT  0xC2   ; Отключить видео ОЗУ
        RET
#endasm
} //GrTiles_DrawTile_fastcall
