/* Ofront+ 1.0 -mx3f -21 */
#include "SYSTEM.oh"
#include "GrApp.oh"
#include "GrTiles.oh"
#include "Rsrc.oh"
#include "Control.oh"
#include "Lvov.oh"
#include "RK86.oh"


static SET Bolder16K_keys;
static CHAR Bolder16K_x, Bolder16K_y;


static void Bolder16K_SetTable (void);


/*============================================================================*/

static void Bolder16K_SetTable (void)
{
	SHORTINT scr, tab;
	CHAR n, val;
	scr = 16388;
	tab = 0;
	n = 0;
	while (n <= 254) {
		val = __MASK(scr, -256);
		__PUT(tab, val, CHAR);
		val = __ASHR(scr, 8, SHORTINT);
		__PUT(tab + 256, val, CHAR);
		tab += 1;
		scr += 64;
		n += 1;
	}
}


int main (int argc, char **argv)
{
	__INIT(argc, argv);
	__IMPORT(Control__init);
	__IMPORT(GrTiles__init);
	__IMPORT(Lvov__init);
	__IMPORT(RK86__init);
	__IMPORT(GrApp__init);
	__REGMAIN("Bolder16K", 0);
/* BEGIN */
	Bolder16K_SetTable();
	Bolder16K_x = 1;
	Bolder16K_y = 1;
	for (;;) {
		Bolder16K_keys = Control_Get();
		if (__IN(4, Bolder16K_keys) && Bolder16K_x < 51) {
			Bolder16K_x += 1;
		}
		if (__IN(6, Bolder16K_keys) && Bolder16K_x > 0) {
			Bolder16K_x -= 1;
		}
		if (__IN(5, Bolder16K_keys) && Bolder16K_y > 0) {
			Bolder16K_y -= 1;
		}
		if (__IN(7, Bolder16K_keys) && Bolder16K_y < 31) {
			Bolder16K_y += 1;
		}
		GrTiles_DrawTile(Bolder16K_x, Bolder16K_y, 32767);
		RK86_WAIT(5000);
	}
	GrApp_Close();
	__FINI;
}
